unit OSData ;
{  묨}
interface
const
  KeyEsc=#27;
  KeyPlus='+';
  KeyMinus='-';
  KeyF1=#59;
  KeyF10=#68;
  KeyDown=#80;
  KeyUp=#72;
  KeyLeft=#75;
  KeyRight=#77;
  KeyDelete=#83;
  KeyTab=#9;
  KeyPageUp=#73;
  KeyPageDown=#81;
  SpeedchangeStep:real=0.05;{%}
  MaxSpeed:real=1000;{ᨬ쭠 ᪮}
  MinSpeed:real=0.1; {쭠 ᪮}
  NumberOfCommands=2;
  MAX_PROCESS=15;{ᨬ쭮 ⢮ ᮢ}
  MAX_PARAMS=7; {⢮ ࠬ஢ }
  MAX_TIMEPARAMS=4; {⢮ ࠬ஢  । ६}
  MAX_QUEUEPROCESSES=100;{ᨬ쭮 ⢮ ᮢ
         । ᮢ}
  MAX_MCB=80; { ᫥  MCB}
  { 樨 ﭨ ᮢ}
  S_processCondition:array[0..10] of String[9]=(
  '      ',
  '    ',
  '  ',
  ' ',
  '.I/O ',
  '. I/O ',
  '..',
  '. IO ',
  '.',
  '..IO',
  ''
  );
  S_CPUCondition:array[0..2] of string[8]=(
  '',
  '',
  '. IO'
  );
  S_CodOperation:array[0..2] of string[8]=(
  '.',
  'I/O     ',
  '. '
  );
   InputFileName:string=('INPUT.TXT');
   ScrollStep=21;
Type
  TProcessCondition=(NONE,READY,ACTIVE,LOAD,InitializingIO,FinishingIO,
     BlockedOnAM,BlockedOnIO,PAUSED,WaitingFinishingIO,Saved);
  TCPUCondition=(WORK,WAITING,INTR_IO);
  TypeCommand=(COMMAND_ARITHMETICAL,COMMAND_IO,COMMAND_EXIT);
  TypeCodOp=(CODOP_ARITHMETICAL, CODOP_IO,CODOP_EXIT);
  TypeOperand=integer;{}
  TypeAdress=integer;{⥬᪨ }
  TProcess=record
  {室 ࠬ :}
   Task_ID,         {䨪  (: 1, 2, 3) }
   V_task,          {ࠧ }
   N_cmnd,          { ⥫쭮-+ 믮 
                    (᫮  ( ⠪⮢!) )}
   D_inOut,         {⢮   (뢮)  業⭮
                     ⭮襭  饬   }
   N_InOut,         {⥫쭮   (뢮)  ⭮襭
                     ᫨⥫ }
   Prior:Word;       {ਮ }

   N_ask_mem:word;{  ⢮   ⥫쭮 }
   N_free_mem:word;  {⢮  ᢮ ⥫쭮 
                     (   N_ask_mem,   ᠬ ᢮
                       㧪 }
   V_ask_mem:word;   {ࠧ 訢 }


   {室 ࠬ :}
   Process:integer;     { }
   Condition:TProcessCondition;  {ﭨ }
   PC_IO,               {稪 ⠪⮢   뢮}
   T_mono,              {६ 믮  ணࠬ }
   T_multi,             {६ 믮    }
   D_exe:longint;       {業 㢥祭 ६ 믮
                            ࠢ  ணࠬ }
   T_Ready:longint;   {६   ⠪}
   D_ready:word;     {६ 宦  ᯨ᪥ ⮢
                         (⮩ )  業  ६
                         믮 }
   Cmnd:Word;          {稪 }

{   Data_Adres;          { ॠ樨  , 
                         㧪, ࠧ ⮩ , ࠧ -
                         襭   . . - ଠ  
                         ⮤ ।}
   {⥫ ࠬ :}
   T_Loaded:integer;     {⢮ ⠪⮢,  த 
                           㦠}
   IOCmndProcess:integer; {⢮ ⠪⮢,  믮
                          ⥪ }
   FirstMCB:byte;         { ࢮ  MCB}
  end;


  type TSection=(SEC_V_ozu,SEC_Kvant,SEC_T_Next,SEC_T_InitIO,SEC_T_IntrIO,
  SEC_T_LOAD,SEC_SPEED,SEC_T_GLOBL,SEC_T_MOVE,SEC_T_ASK_MEM,SEC_V_TASK,SEC_N_CMND,SEC_D_INOUT,
  SEC_N_INOUT,SEC_PRIOR, SEC_N_ASK_MEM,SEC_N_FREE_MEM,SEC_V_ASK_MEM, SEC_END);

  type TGenerateProcessParam=record
    V_task,          {ࠧ }
    N_cmnd,          { ⥫쭮 믮 
                    (᫮  ( ⠪⮢!) )}
    D_inOut,         {⢮   (뢮)  業⭮
                     ⭮襭  饬   }
    N_InOut,         {⥫쭮   (뢮)  ⭮襭
                     ᫨⥫ }
    Prior:Word;   {ਮ }
    N_ask_mem,        {⢮   ⥫쭮 }
    N_free_mem,       {⢮  ᢮
                       ⥫쭮 }
    V_ask_mem:word;    {ࠧ 訢 }{}
    end;
  type TGenerateProcessInfo=record
    Min,Max,Discrete:TGenerateProcessParam;
  end;
  type TView=(VIEW_TIME,VIEW_MEMORY,VIEW_TABLEMEMORY);{ ⠡ ४祭 ०
                                   1-। ६
                                   2-। }
  type TMCB=record                 {襬   ࠢ }
    First:word;                    {䨧᪨  砫 }
    Size:word;                     {ࠧ  }
    Process:byte;                  { , ஬ 뤥 }
    Next:byte;                     { ᫥饣 MCB}
  end;
{ ६}
var
   Quit:boolean;
   AutoQuit:boolean;
   CountTiks:longint absolute $0040:$006C;
   LastCountTiks:longint;
   TaktBeforeDelay:integer;{६  믮 প}

{室 ࠬ :}
   OZUSize,           {  }
   OZUFreeSize:longint; {ࠧ ᢮  }
   Kvant,           { ६ (᫮ ⠪⮢ ஢, 㯭
                      ﭨ "⨢")}
   T_next,          {   롮   믮 
                     (⠪⮢ 㥬 ६)}
   T_CurNext,       {⥪騥    T_Next }
   T_InitIO,         {    ﭨ   饭
                      (뢮) ( ᫥ ⠪⮢)}
   T_IntrIO,         {    㦨 ᨣ 砭
                    (뢠)  (뢮) ( ᫥ ⠪⮢)}
   T_Load:Word;  {᫮ ⠪⮢  㧪  }
   Speed:real;      { ࠡ  ⠪⮢  1 ᥪ㭤}

   T_Globl:integer; {   饭  騬 묨 (
                    ⨯୮ )}
   CurKvant:integer; {- ⠪⮢,  ⥪騩  - 
                     ﭨ ⮢.}

  { V_razdel:longint; {ࠧ ࠧ}
   T_move:word;      {   ४}
   T_ask_mem:word;   {    ᢮ 쭨⥫쭮 }
{室 ࠬ 業ࠫ쭮 }
   PC:longint ;{稪 }
   CurProc:integer;               { 믮塞  }
   Command: TCPUCondition;      {믮塞   }
   CodOperation:TypeCodOp;
   Operand1,Operand2:TypeOperand;
{室 ࠬ :}
   Cmnd:integer;        {稪 }
   N_Procc:integer;     {᫮ 㦥 }
   D_sys:real;       {⥬   ( 業 뢮)}
   D_CountSys:longint;  {稪  ⥬}
   D_NCountSys:longint;
   T_multi:longint;     {६ ࠡ     ᪠}
   M_multi:integer;     {᫮ 믮    砫
                         ஢}
   T_mono:longint;      {६ 믮 M_multi  
                         ணࠬ ⥬}
   M_mono,              {᫮ ,     믮
                         ६ T_multi  ணࠬ  }
   D_multi:integer;     {ந⥫쭮    ࠢ
                         ணࠬ   業}
   N_frac: longint;     {ࠣ   }
   D_frac:longint;      {ࠣ   業}
   N_in_frac:longint;   {७ ࠣ}
   D_in_frac:longint;   {७ ࠣ  業}

   {ᨢ ᮢ}
   Process:array [0..MAX_PROCESS] of TProcess;
   ProcessDefault:TProcess;
   NextTask_ID:integer;

   {न  뢮:}
   ProcessesBoxX,ProcessesBoxY:integer;{न  ᮢ}
   SettingsboxX,SettingsBoxY:integer;  {न  ஥ ᪮...}
   CPUBoxX,CPUBoxY:integer;            {न  }
   SystemBoxX,SystemBoxY:integer;      {न  ⥬}
   ControlBoxX,ControlBoxY:integer;
   QueueProcessesBoxX,QueueProcessesBoxY:integer;{न  뢮
            ᫥饣   । ᮢ}
   { ⥭ 室 ᮢ  䠩}
   {QueueProcesses:array[0..MAX_QUEUEPROCESSES] of TQueueProcesses;}
   GenerateProcessInfo:TGenerateProcessInfo;
   UsedTaktsForMono:longint;{ᯮ짮 ⠪ ୮ ⥬
      ᫥ M_mono}
   {ୠ ࠡ 9. ४⨢ }
   SelectedProcess:integer;{࠭   㤠}
   SelectedParam:integer;{࠭ ࠬ }
   CurrentNumber:integer;{⥪ 塞 }
   Currentparam:longint;{⥪騩 ࠬ}
   AutomaticLoadProcesses:boolean;{/몫 ⮬. 㧪 }
   Loading:word;

   {ᨢ 뢠  ࠡ⪨ 뢠}
   Intr:array[0..MAX_PROCESS] of integer; { ⮬ ᨢ  ࠭
          ᮢ,  㦭 ࠡ⪠ 뢠}
   FirstIntr,EndIntr:integer; {    । 뢠}
   SavedCmnd:longint;   { ࠭ }
   SavedCommand:TCPUCondition; { ࠭ ﭨ }

   View:TView;   {० ᬮ । ,
                  । ६}
   TableScrollValue:Word;{騩 㪠⥫ ப⪨  TABLEMEMORY}
   MCB:array [0..MAX_MCB] of TMCB;    {ᨢ, 뢠騩  }
   RankedMCB:array[1..MAX_MCB] of TMCB;
   FreeMCB:array[1..MAX_MCB] of byte; {ᨢ, 뢠騩 ᢮ }
   {BusyMCB:array[1..MAX_MCB] of byte; {ᨢ, 騩  }
   FreePos,BusyPos:byte; { ᢮   ᮮ⢥⢥}

implementation

end.