unit OSIOCPU;
{  뢮}
interface
  Procedure InitIO;
  {ࠡ⪠ ஢  뢮}
  Procedure ProcessIOCPU;
  Procedure ProcessInitializingIO(n:integer);
implementation

uses OSData,OSSVTime,OSProc;

Procedure InitIO;
var Cond:TProcessCondition;
    n:integer;
begin
  n:=CurProc;
  Cond:=Process[n].Condition;
  SaveProcess(CurProc);
  CurKvant:=0; CurProc:=-1;
  ChangeProcess;
  Process[n].Condition:=InitializingIO;
  Process[n].IOCmndProcess:=0;
  if (T_initIO=0) Then ProcessInitializingIO(n);
end;

Procedure ProcessInitializingIO(n:integer);
begin
  inc(Process[n].IOCmndProcess);
  if (Process[n].IOCmndProcess>=T_InitIO) then
  begin
    Process[n].Condition:=BlockedOnIO;
    if (T_IntrIO=0) Then Process[n].IOCmndProcess:=0 else T_IntrIO:=1;

  end
{  else
   begin}

{  end;}
end;

Procedure ProcessBlockedOnIO(n:integer);
begin
  inc(Process[n].IOCmndProcess);
  if (Process[n].IOCmndProcess>=Process[n].N_InOut) then
  begin
    if (T_IntrIO>0) Then
    begin
      Process[n].Condition:=WaitingFinishingIO;
      Process[n].IOCmndProcess:=0;
      AddInterrupt(n);
      Process[n].Condition:=WaitingFinishingIO;
    end
    else
    begin
     Process[n].Condition:=READY;
     Inc(Process[n].PC_IO);
    end;
  end
{  else
  begin}

{  end;}
end;

{믮  
Procedure ProcessFinishingIO(n:integer);
begin

end;}

Procedure ProcessIOCPU;
var n:integer;
begin
  for n:=0 to MAX_PROCESS do
  begin
    case (Process[n].Condition) of
    InitializingIO: ProcessInitializingIO(n);
    BlockedOnIO:  ProcessBlockedOnIO(n);
{    WaitingFinishingIO: ProcessFinishingIO(n);}
        {  몫祭 ᪮  ࠡ뢠  IO     CPU}
        {
        if (Process[n].IOCmndProcess=T_IntrIO) then
        begin
          Process[n].Condition:=READY;
          inc (Process[n].PC_IO);
          Inc(Process[n].Cmnd);
        end
        else
        begin
          inc(Process[n].IOCmndProcess);
        end;}
    end; {case}
  end;   {for}
end;     {procedure}

end.