unit OSSVMEM;
interface
  function CheckOZU(Size:Word;var First:word):boolean;
  Function GetFreeMCB:byte;
  Function AddFreeMCB(n:byte):boolean;
  Function AddBusyMCB(n:byte):boolean;
  Function RemoveBusyMCB(n:byte):boolean;
implementation
uses OSData;

Function GetInceassantBlock(Size:word):word;
var First:word;
    n,k:byte;
    yes:boolean;
begin
  {RegularizeMCB;}
  First:=0;
  yes:=TRUE;
  for k:=1 to BusyPos do
  begin
    n:=FreeMCB[k];
    if (MCB[n].Size=0) Then continue;
    yes:=FALSE;
{    if (MCB[n].First>=First) and (MCB[n].First<First+Size) Then yes:=FALSE;
    if (MCB[n].First+MCB[n].Size>First) and (MCB[n].First+MCB[n].Size<First+Size) Then yes:=FALSE;}
    if (First<MCB[n].First) and (First+Size<MCB[n].First) Then yes:=TRUE;
    if (First>=MCB[n].First+MCB[n].Size) Then yes:=TRUE;
    if (yes) Then
    begin
      {GetInceassantBlock:= First; exit;}
    end
    else
    begin
        if (First<MCB[n].First+MCB[n].Size) Then First:=MCB[n].First+MCB[n].Size;
        if (First+Size<OZUSize) Then
        begin
         yes:=FALSE;
         k:=0;
        end
        else
        begin
          break;
        end;
    end;
  end;
  if (yes) then GetInceassantBlock:=First else
  GetInceassantBlock:=OZUSize;
end;


function CheckOZU(Size:Word; var First:word):boolean;
var yes:boolean;
  n:integer;
begin
  if (OZUFreeSize<Size) then yes:=FALSE
  else yes:=TRUE;
  if (yes) Then
  begin
    First:=GetInceassantBlock(Size);
    if (First>=OZUSize) Then yes:=FALSE;
  end;
  CheckOZU:=yes;
end;

Procedure RegularizeMCB;
var n,m:integer;
    buf:TMCB;
begin
  for n:=1 to MAX_MCB do
  begin
    for m:=n to MAX_MCB do
    begin
      if (MCB[n].First>MCB[m].First) and (MCB[m].Size>0) and (MCB[n].Size>0) Then
      begin
        buf:=MCB[n];
        MCB[n]:=MCB[m];
        MCB[m]:=buf;
      end;
    end;
  end;
end;

Function GetFreeMCB:byte;
var n:byte;
begin
{  For n:=1 to MAX_MCB do
  begin
    if (MCB[n].Size=0) Then begin GetFreeMCB:=n; exit; end;
  end;}
  if (FreePos=MAX_MCB) Then GetFreeMCB:=0
  else
  begin
    GetFreeMCB:=FreeMCB[FreePos];
    Inc(FreePos);
  end;

end;


Function AddFreeMCB(n:byte):boolean;
begin
  if (FreePos=0) Then
  begin
    AddFreeMCB:=FALSE;
    exit;
  end;
  MCB[n].Size:=0;
  MCB[n].First:=0;
  MCB[n].Process:=0;
  Dec(FreePos);
  FreeMCB[FreePos]:=n;
  AddFreeMCB:=TRUE;
end;

Function AddBusyMCB(n:byte):boolean;
begin
  if (BusyPos=MAX_MCB) Then
  begin
    AddBusyMCB:=FALSE;
    exit;
  end;
  Inc(BusyPos);
  FreeMCB[BusyPos]:=n;
  AddBusyMCB:=TRUE;
end;

Function RemoveBusyMCB(n:byte):boolean;
var k,b:byte;
    First,Size:word;
begin
  if (BusyPos=0) Then
  begin
    RemoveBusyMCB:=FALSE;
    exit;
  end;
  First:=MCB[n].First;
  Size:=MCB[n].Size;
  for b:=1 to BusyPos do if (FreeMCB[b]=n) Then break;

  for k:=b to BusyPos do
  begin
    FreeMCB[k]:=FreeMCB[k+1];
  end;
  FreeMCB[BusyPos]:=0;
  Dec(BusyPos);
  {६頥 ࠧ}
  for k:=1 to BusyPos do
  begin
    if (MCB[FreeMCB[k]].First>=First+Size) Then
    begin
      Dec(MCB[FreeMCB[k]].First,Size);
    end;
  end;
  RemoveBusyMCB:=TRUE;
end;

end.