unit OSPrint;
{  뢮  ࠭}
interface
uses OSData;
  {뢮 ᥣ  ࠭}
  Function PrintAll:boolean;
  Procedure ShowHelp;
implementation
uses Crt;

Procedure SetSelectText;
begin
  TextColor(BLACK);
  TextBackGround(LIGHTGRAY);
end;

Procedure SetNormalText;
begin
  TextColor(LIGHTGRAY);
  TextBackGround(BLACK);
end;

Function PrintProcesses:boolean;
var n,IOCmndProcess:integer;
begin
  gotoxy(ProcessesBoxX,ProcessesBoxY);
  write('  .    . - . - IO ﭨ IO IO  . - -');
  for n:=0 to MAX_PROCESS do
  begin
    case (Process[n].Condition) of
    InitializingIO: IOCmndProcess:=T_InitIO-Process[n].IOCmndProcess;
    BlockedOnIO:IOCmndProcess:=Process[n].N_INOut-Process[n].IOCMndProcess;
    FinishingIO:IOCmndProcess:=T_IntrIO-Process[n].IOCMndProcess;
    else IOCMndProcess:=0;
    end;
    GotoXY(ProcessesBoxX,ProcessesBoxY+n+1);
    if (SelectedProcess=n) Then begin TextColor(BLACK); TextBackground(LIGHTGRAY);end;
    write(n:2,
      Process[n].Task_ID:6,
      Process[n].Cmnd:6,'/',  Process[n].N_cmnd:5,
      Process[n].V_Task:6,
      Process[n].Prior:6,
      Process[n].D_InOut:5,'%',
      S_ProcessCondition[integer(Process[n].Condition)]:11,
      Process[n].PC_IO:5,
      IOCmndProcess:3,
      Process[n].T_Mono:5,
      Process[n].T_multi:6,
      Process[n].D_exe:5,'%',
      Process[n].D_ready:4,'%'
      );
      if (SelectedProcess=n) Then begin TextColor(LIGHTGRAY); TextBackground(BLACK);end;
  end;
end;

Function PrintSettings:boolean;
begin
  gotoxy(SettingsBoxX,SettingsBoxY);
  Write('-: ',Speed:4:3); Writeln(' ');
  gotoxy(SettingsBoxX,SettingsBoxY+1);
  write('. . -: ',T_Load);
  gotoxy(SettingsBoxX,SettingsBoxY+2);
  write(': ',CurKvant:5,'/',Kvant:5);
  gotoxy(SettingsBoxX,SettingsBoxY+3);
  write('T . -: ',T_Next);
  gotoxy(SettingsBoxX,SettingsBoxY+4);
  write('T . IO:',T_InitIO);
  gotoxy(SettingsBoxX,SettingsBoxY+5);
  write('T . IO:',T_InitIO);
end;

Function PrintCPU:boolean;
begin
  gotoxy(CPUBoxX,CPUBoxY);
  Write(': ',PC:10);
  gotoxy(CPUBoxX,CPUBoxY+1);
  Write('. ',S_CPUCondition[integer(Command)]);
  gotoxy(CPUBoxX,CPUBoxY+2);
  Write(': ',Cmnd:5);
  gotoxy(CPUBoxX,CPUBoxY+3);
  write(' -:',S_CodOperation[integer(CodOperation)] );
  gotoxy(CPUBoxX,CPUBoxY+4);
  write('. :');if (CurProc>=0) then write(Process[CurProc].Task_ID:5) else write('     ' );
end;

Function PrintSystem:boolean;
var r,r1:real;{ ᫥ ⥬ }
begin
  gotoxy(SystemBoxX,SystemBoxY);
  if (M_mono<>0) Then
    D_multi:=Round(M_multi/M_mono*100)
  else
    D_multi:=0;
  if (M_multi<>0) Then
  begin
    r:= T_mono/M_multi;{塞 । ६ 宦 
                         ணࠬ ⥬}
{    ᯮᮡ ⮦ ࠡ⠥:
    r1:=T_mono-T_multi;
    if (r<>0) Then M_mono:=M_multi-Round(r1/r);}
    if (r<>0) Then M_mono:=Trunc(T_multi/r);
  end;
  {
  if (T_multi<>0) Then D_multi:=Round(T_mono/T_multi)*100;
  if (D_multi<>0) and (M_multi<>0) Then M_mono:=Round(1/(D_Multi/100)*M_Multi);
  }
  if (M_multi<>0) Then r:=T_multi/M_multi else r:=0;
  Write('ந.: ',D_multi:3,'%',': ',(r):4:0);
  gotoxy(SystemBoxX,SystemBoxY+1);
  Write('. .: ',OZUFreeSize:5,'/',OZUSize:5);
  gotoxy(SystemBoxX,SystemBoxY+2);
  Write('- . M|O: ', M_multi:3,'|',M_mono:3);
  gotoxy(SystemBoxX,SystemBoxY+3);
  write('- -: ',N_Procc:3);
  gotoxy(SystemBoxX,SystemBoxY+4);
  write('T. .:',T_mono:10);
  if ((T_multi<>0) and (D_CountSys<>0)) then  r:=D_CountSys/T_multi else r:=0;
  D_Sys:=r*100;
  gotoxy(SystemBoxX,SystemBoxY+5);
  write('. -:',Round(D_Sys):4,'%     ');
end;

Procedure PrintControl(ControlBoxX:integer;ControlBoxY:integer);
begin
   gotoxy(ControlBoxX,ControlBoxY);
   writeln('"-"/"+"-. ᪮.');
   gotoxy(ControlBoxX,ControlBoxY+1);
   write('"N"-. -');
   gotoxy(ControlBoxX,ControlBoxY+2);
   if (AutomaticLoadPRocesses) Then SetSelectText;
   write('"C"-. . -');
   SetNormalText;
   gotoxy(ControlBoxX,ControlBoxY+3);
   write(Chr(30),',',Chr(31),',Del-- -.');
   gotoxy(ControlBoxX,ControlBoxY+4);
   writeln(Chr(16),',',Chr(17),',Num- -');
   gotoxy(ControlBoxX,ControlBoxY+5);
   write('"Esc"-, ');
   if (AutoQuit) Then SetSelectText;
   write('F10-.');
   SetNormalText;
end;

Procedure PrintQueueProcesses(QueueProcessesBoxX,QueueProcessesBoxY:integer);
var F,n:integer;
Procedure SetColors;
begin
  if (SelectedParam=n) Then begin TextColor(BLACK);TextBackground(LIGHTGRAY); end
  else begin TextColor(LIGHTGRAY); TextBackground(BLACK); end;
end;
begin
  gotoxy(QueueProcessesBoxX,QueueProcessesBoxY);
  write('. .:'); n:=0;
  SetColors;
  write(' ࠧ.:',ProcessDefault.V_Task:5);Inc(n);
  SetColors;
  write(' - -:',ProcessDefault.N_cmnd:5);Inc(n);
  SetColors;
  write(' % IO:',ProcessDefault.D_InOut:5,'%');Inc(n);
  SetColors;
  write(' T. - IO:',ProcessDefault.N_InOut:5);Inc(n);
  SetColors;
  write(' :',ProcessDefault.Prior:5);Inc(n);
  SetColors;
end;

Procedure MemoryPrintSettings(SettingsBoxX:integer;SettingsBoxY:integer);
begin
  gotoxy(SettingsBoxX,SettingsBoxY);
  Write('-: ',Speed:4:3); Writeln(' ');
  {gotoxy(SettingsBoxX,SettingsBoxY+1);
  write('. ࠧ.:',V_Razdel:5);}
  gotoxy(SettingsBoxX,SettingsBoxY+2);
  write(' ४-:',T_move:5);
  gotoxy(SettingsBoxX,SettingsBoxY+3);
  write(' / .:',T_ask_mem:5);
  gotoxy(SettingsBoxX,SettingsBoxY+4);
end;

Procedure MemoryPrintProcesses(ProcessesBoxX,ProcessesBoxY:integer);
var n:integer;
begin
  gotoxy(ProcessesBoxX,ProcessesBoxY);
  writeln('  .  . . . . . . ..  .');
  for n:=0 to MAX_PROCESS do
  begin
     SetNormalText;
     if (SelectedProcess=n) Then SetSelectText;
    writeln(n:2,
        Process[n].Task_ID:6,
        Process[n].N_ask_mem:9,
        Process[n].N_free_mem:8,
        Process[n].V_ask_mem:15,
        MCB[Process[n].FirstMCB].First:6,
        MCB[Process[n].FirstMCB].First+MCB[Process[n].FirstMCB].Size:6);
  end;

end;

Procedure MemoryPrintSystem(SystemBoxX,SystemBoxY:integer);
begin
  gotoxy(SystemBoxX,SystemBoxY);
end;

Procedure MemoryPrintQueueProcesses(QueueProcessesBoxX,QueueProcessesBoxY:integer);
var F,n:integer;
Procedure SetColors;
begin
  if (SelectedParam=n) Then begin TextColor(BLACK);TextBackground(LIGHTGRAY); end
  else begin TextColor(LIGHTGRAY); TextBackground(BLACK); end;
end;
begin
  gotoxy(QueueProcessesBoxX,QueueProcessesBoxY);
  write('. .:'); n:=5;
  SetColors;
  write('  .:',ProcessDefault.N_ask_mem:5);Inc(n);
  SetColors;
  write(' . .:',ProcessDefault.N_free_mem:5);Inc(n);
  SetColors;
  write(' . .:',ProcessDefault.V_ask_mem:5);Inc(n);
  SetColors;
{  write(' T. - IO:',ProcessDefault.N_InOut:5);Inc(n);
  SetColors;}
{  write(' :',ProcessDefault.Prior:5);Inc(n);}
{  SetColors;                                      }
end;

procedure MemoryPrintMemory;
const MAX_Y=24;
      MAX_X=70;
var n,x,y,m:integer;
    cur,ncur:Word;{cur - 砫  ⥪饣 }
                     {ncur -   ⥪饣 }
    Proc:integer;
    s:string[2];

procedure PrintBlock;
var    k:longint;
begin
    str(proc,s);
    if (ncur>cur) Then begin s:=chr(1) end else ncur:=MCB[m].First+MCB[m].Size;

    for k:=cur to ncur-1 do
    begin
      if (x>=MAX_X) Then
      begin
        x:=8; Inc(y);
        if (y>=MAX_Y) Then break;
        gotoxy(1,y);write(k:5,':');
      end;

      gotoxy(x,y);
      write(s:3);
      cur:=ncur;
      inc(x,3);
    end;
end;
begin
  gotoxy(1,1);
  writeln(' :');
  cur:=TableScrollValue; x:=MAX_X;y:=1;
  for n:=1 To BusyPos do
  begin
    if (cur>=MCB[FreeMCB[n]].First)
    and (cur<MCB[FreeMCB[n]].Size+MCB[FreeMCB[n]].First) Then
    begin
      Proc:=MCB[FreeMCb[n]].Process;
      s:=char(proc+ord('0'));
      ncur:=cur;
      m:=FreeMCB[n];
      PrintBlock;
      break;
    end;
  end;

  while (cur<OZUSize) do
  begin
    if y>=MAX_Y Then break;
    ncur:=OZUSize; Proc:=-1;
    {宦   }
    for n:=1 to BusyPos do
    begin
      if (MCB[FreeMCB[n]].First<ncur) and (MCB[FreeMCB[n]].First>=cur) Then
      begin
        ncur:=MCB[FreeMCB[n]].First;
        Proc:=MCB[FreeMCB[n]].Process;
        m:=FreeMCB[n];
      end;
    end;
    {நᮢ }
    PrintBlock;
  end;
  if (y<MAX_Y)  Then
  begin
    s:=' ';
    for n:=1 to MAX_X-x+(MAX_Y-y)*MAX_X do
    begin
      write(s);
    end;
  end;
  gotoxy(1,24); write('ᯮ  "PageUp"  "PageDown"  ப⪨.');
end;

Function PrintAll:boolean;
begin
 GotoXY(1,1);
 case View of
   VIEW_TIME:
   begin
     PrintCPU;
     PrintSettings;
     PrintProcesses;
     PrintSystem;
     PrintControl(ControlBoxX,ControlBoxY);
     PrintQueueProcesses(QueueProcessesBoxX,QueueProcessesBoxY);
   end;
   VIEW_MEMORY:
   begin
     MemoryPrintSettings(SettingsBoxX,SettingsBoxY);
     MemoryPrintProcesses(ProcessesBoxX,ProcessesBoxY);
     MemoryPrintSystem(SystemBoxX,SystemBoxY);
     MemoryPrintQueueProcesses(QueueProcessesBoxX,QueueProcessesBoxY);
   end;
   VIEW_TABLEMEMORY:
   begin
     MemoryPrintMemory;
   end;
 end;
 gotoxy(1,25);
 write('  ᮧ ࢠ ஬ ᫠祬  2006 . "F1"-ࠢ.');
end;

Procedure ShowHelp;
begin
   clrscr;
   writeln('  ࠢ. ');
   writeln('  ࠢ:');
   PrintControl(1,3);
   writeln('"N"-  ');
   writeln('Tab - ४  ० (, ,  ).');
   writeln('᫨  ० ⮬᪮ 㧪  ( "C"), ');
   writeln('  ⮬᪨ 㦠  । .');
   writeln('᫨ F10  (ப "F10-" 뤥 ࠭),  ணࠬ ');
   writeln('᢮ ࠡ ᫥ 믮 .');
   writeln('  ࠬ   ப:');
   writeln('"/?- ࠢ"');
   writeln('    묨: ');
   writeln('  묨 "INPUT.TXT" 室  ⠫ ணࠬ.');
   writeln('  ᠭ ࠬ ⥬  । ᮢ.ଠ ');
   writeln('<> <ᨬ> <⭮>. ࠬ   -');
   writeln('  <>  <ᨬ>  ⭮ <⭮>.');
   writeln('      த...');
   ReadKey;
   clrscr;

end;


end.