unit OSProc;
{ ࠡ⪨ ᮢ}
interface
  uses OSData;
  {㭪 ࠡ⪨ 1 ⠪}
  Function ProcessTakt:boolean;
  {㭪 樨 }
  Function GenerateProcess:boolean;
  {㭪 樨 ᮢ ᯮ GenerateProcess}
  Function GenerateProcesses:boolean;
  {㭪 ᮧ ࠬ  Default  ᨭࢠ}
  Function GenerateDefaultProcessParameters:boolean;
  Function LoadProcesses:boolean;
  { }
  Procedure DeleteProcess(DelProc:integer);

  { 뢠 砭  뢮}
  Procedure AddInterrupt(n:integer);
  { 뢠 砭 -뢮}
  Procedure RemoveInterrupt;
Function GetT_Mono(N_Cmnd:word;D_InOut:Word; N_InOut:Word):longint;
implementation
uses OSSVTime,OSSVMem,OSCPU,OSIOCPU;  {ᯮ 㯥ࢨ ६}

Function GenerateProcess:boolean;
var n,m,k:integer;
    yes:boolean;
    First:Word;
begin
  n:=0;  yes:=false;
  while (n<=MAX_PROCESS) and (Process[n].Condition<>NONE) do inc(n);
  if (n>MAX_PROCESS) Then begin GenerateProcess:=FALSE;exit; end;
  if (CheckOZU(ProcessDefault.V_Task,First)=TRUE) then
  begin
    Process[n]:=ProcessDefault;
    Dec(OZUFreeSize,process[n].V_Task);
    while  (not yes) do
    begin
      inc(NextTask_ID);
      yes:=TRUE;
      for  m:=0 to MAX_PROCESS do
      begin
        if (Process[m].Task_ID=NextTask_ID) Then yes:=FALSE;
      end;
    end;
    Process[n].Task_ID:=NextTask_ID;
    Process[n].T_Mono:=GetT_mono(Process[n].N_Cmnd,Process[n].D_InOut,Process[n].N_InOut);
    k:=GetFreeMCB;
    AddBusyMCB(k);
    MCB[k].First:=First;
    MCB[k].Size:=ProcessDefault.V_Task;
    MCB[k].Process:=n;
    MCB[k].Next:=0;
    Process[n].FirstMCB:=k;
    Inc(N_Procc);
    GenerateDefaultProcessParameters;
  end
  else
  begin
    GenerateProcess:=FALSE;
  end;
end;

Function GenerateProcesses:boolean;
var n:integer;
begin
  for n:=0 to MAX_PROCESS do
  begin
     GenerateProcess;
  end;
end;

Function MyDelay:boolean;
var yes:boolean;
begin
  yes:=TRUE;
  if (Speed>=18) then
  begin
    if (TaktBeforeDelay=0) then
    begin
      if (((Counttiks-LastCountTiks) )<1) then yes:=FALSE
      else
      begin
        LastCountTiks:=CountTiks;
        TaktBeforeDelay:=Round(Speed /18);
      end;
    end
  end
  else
  begin
    if (((Counttiks-LastCountTiks) )<Round(18/Speed) ) then yes:=FALSE
    else    LastCountTiks:=CountTiks;
  end;
  MyDelay:=yes;
end;

Procedure ChangeProcessParams;
var n:integer;
    r:real;
    T_mono:longint;
begin
  for n:=0 to MAX_PROCESS do
  begin
    if (Process[n].Condition<>NONE) then
    begin
      Inc(Process[n].T_multi);
      r:=(Process[n].T_multi)/Process[n].T_mono;
      Process[n].D_exe:=Round(r*100);
      if (Process[n].Condition=READY) Then
      begin
        Inc(Process[n].T_Ready);
        if (Process[n].T_multi<>0) Then
          Process[n].D_Ready:=Round(100*(Process[n].T_Ready/Process[n].T_multi))
        else
          Process[n].D_Ready:=0;
      end;
      T_mono:=GetT_mono(Process[n].N_cmnd,Process[n].D_InOut,Process[n].N_InOut);
      if (Process[n].T_multi<T_mono) Then
        Process[n].T_mono:=Process[n].T_multi
      else
        Process[n].T_mono:=T_mono;
    end;
  end;
end;

Procedure CalculateM_Mono;
begin

end;

Function ProcessTakt:boolean;
begin
  if ((N_Procc=0)and (AutoQuit)) Then Quit:=TRUE;
  if (MyDelay) or (Loading>0) then
  begin
    DoTakt;
    ProcessIOCPU;
    Dec(TaktBeforeDelay);
    ChangeProcessParams;
    Inc(T_multi);
    if ((CurKvant=0) or(CurProc=-1)) and (Command<>INTR_IO) then      ChangeProcess;
    if (N_Procc<=MAX_PROCESS) and (AutomaticLoadProcesses)and (not AutoQuit) Then  GenerateProcess;
    {᫥ - -   ணࠬ ⥬:}
    CalculateM_Mono;
    if (Loading>0) Then Dec(Loading);
  end;
end;

Function LoadProcess(n:integer):boolean;
begin
   Inc(Process[n].T_Loaded);
   Inc(Process[n].PC_IO);
   {᫨  㧨,  ⠢  ﭨ }
   if (Process[n].T_Loaded=T_Load) then Process[n].Condition:=READY;
end;

Function LoadProcesses:boolean;
var n:integer;
begin
  for n:=0 to MAX_PROCESS do
  begin
    if (Process[n].Condition=LOAD) then LoadProcess(n);
  end;
end;

Function GetT_Mono(N_Cmnd:word;D_InOut:Word; N_InOut:Word):longint;
begin
  GetT_mono:=T_load+Round(N_cmnd*(D_InOut/100)
    *N_InOut+N_cmnd
    *((100-D_InOut)/100));
end;

Procedure DeleteProcess(DelProc:integer);
var   m,k:integer;
var Cond:TProcessCondition;
var p:^byte;
      n:byte;
      label m_loop;
begin
  if (Process[DelProc].Condition=NONE) Then Exit;
  Dec(N_Procc);
  m:=DelProc;
  Cond:=Process[m].Condition;
  CurKvant:=0;
  if (DelProc=CurProc)Then begin CurProc:=-1;   ChangeProcess;end;
  n:=SizeOf(TProcess);
  p:=@(Process[m]);
  Inc(OZUFreeSize,Process[m].V_Task);
  k:=Process[m].FirstMCB;
  RemoveBusyMCB(k);
  AddFreeMCB(k);

{  while (k<>0) do
  begin
    MCB[k].Size:=0;
    k:=MCB[k].Next;
  end;}
  Process[m].FirstMCB:=0;
  while (n>0) do
  begin
     dec(n);
     p^:=0;
     inc( p);
    end;
    Process[m].Condition:=NONE;
  if (AutomaticLoadProcesses)and (not AutoQuit)Then GenerateProcess
end;

Function GenerateParameter(Min,Max,Discrete:WORD):WORD;
begin
   GenerateParameter:=Min+((Random(Max-Min) )DIV Discrete )*Discrete;

end;

Function GenerateDefaultProcessParameters:boolean;
begin
  ProcessDefault.V_Task:=generateParameter(GenerateProcessInfo.Min.V_Task,
    GenerateProcessInfo.Max.V_Task,
    GenerateProcessInfo.Discrete.V_Task);
  ProcessDefault.N_cmnd:=generateParameter(GenerateProcessInfo.Min.N_Cmnd,
    GenerateProcessInfo.Max.N_Cmnd,
    GenerateProcessInfo.Discrete.N_CMnd);
  ProcessDefault.D_InOut:=generateParameter(GenerateProcessInfo.Min.D_InOut,
    GenerateProcessInfo.Max.D_InOut,
    GenerateProcessInfo.Discrete.D_InOut);
  ProcessDefault.N_InOut:=generateParameter(GenerateProcessInfo.Min.N_InOut,
    GenerateProcessInfo.Max.N_InOut,
    GenerateProcessInfo.Discrete.N_InOut);
  ProcessDefault.Prior:=  generateParameter(GenerateProcessInfo.Min.Prior,
    GenerateProcessInfo.Max.Prior,
    GenerateProcessInfo.Discrete.Prior);
    {। :}
  ProcessDefault.N_ask_mem:=  generateParameter(GenerateProcessInfo.Min.N_ask_mem,
    GenerateProcessInfo.Max.N_ask_mem,
    GenerateProcessInfo.Discrete.N_ask_mem);
  ProcessDefault.N_free_mem:=  generateParameter(GenerateProcessInfo.Min.N_free_mem,
    GenerateProcessInfo.Max.N_free_mem,
    GenerateProcessInfo.Discrete.N_free_mem);
  ProcessDefault.V_ask_mem:=  generateParameter(GenerateProcessInfo.Min.V_ask_mem,
    GenerateProcessInfo.Max.V_ask_mem,
    GenerateProcessInfo.Discrete.V_ask_mem);



  if (T_Load=0) Then ProcessDefault.Condition:=READY;
end;

Procedure AddInterrupt(n:integer);
begin
  Intr[FirstIntr]:=n;
  Inc(FirstIntr);
  FirstIntr:=FirstIntr mod (MAX_PROCESS+1);
end;

Procedure RemoveInterrupt;
begin
  Inc(EndIntr);
  EndIntr:=EndIntr mod (MAX_PROCESS+1);
end;


end.
